//KT0837_4.c
#include "HT46F47E.h"
// Ansteuerung von I2c-ICs
// Ansteuerung eiens KT0837  in einem Scan-Radio
#include "HT46F47E.h"

#pragma vector isr_4 @ 0x4
#pragma vector isr_8 @ 0x8
#pragma vector isr_c @ 0xc

//ISR for safequard
void isr_4(){} // external ISR
void isr_8(){} // timer/event 0
void isr_c(){} // timer/event 1

#define txd _pd0

#define SDA _pb2
#define SCL _pb3

#define E_LCD _pb1
#define RS_LCD _pb0


unsigned char n,i,c,A_Reg,E_Reg,j,dat,dat_hi,dat_low;
unsigned char F_low,F_hi,L_low;  
unsigned long F,F_high,L;
//initialize registers for safeguard
void safeguard_init(){
	_intc = 0;
	_tmrc = 0;
	_tmr = 0;
	_pac = 0xff; //input mode
	_pbc = 0xff;
}


//a long time delay
void mydelay(unsigned int times){
	while(times--)	_delay(4000);
}

void i2cdelay()
{
for(n=0;n<1024;n++);
}

void shortdelay()
{
for(n=0;n<5;n++);
}

void WrCOM()
{
	txd=1;
	shortdelay();	
    for(c=0;c<8;c++) 
{	
	if((A_Reg & 1)==0)
	{
	txd=1;
	}
	else
	{
	txd=0;
	}
	shortdelay();
	A_Reg=A_Reg>>1;                // Inhalt von E_Reg 1 Bit nach rechts schieben
}	
   
    txd=0;	
   shortdelay();
}


//Funktionen zur I2C_Ansteuerung

void I2c_init()
{
SDA=1;
mydelay(1);
SCL=1;
}	

void pulse_SCL()
{
SCL=1;
mydelay(1);
SCL=0;
mydelay(1);
}	

void I2c_start()
{
SDA=0;
mydelay(1);
SCL=0;
}

void I2c_stop()
{
SDA=0;
mydelay(1);
SCL=1;
mydelay(1);
SDA=1;
}

void I2c_ack()
{
SDA=0;
pulse_SCL();
	
}
		
void I2c_noack()
{
SDA=1;
mydelay(1);
pulse_SCL();
}

void I2c_write()
{
_pbc2=0;  //_pb2 ist Ausgang
dat=E_Reg;
for (j=0;j<8;j++)
{
if(dat & 128)  
{
SDA=1;
//A_Reg=1;
}
else
{
SDA=0;
//A_Reg=0;
}
//WrCOM();
mydelay(1);
pulse_SCL();
dat=dat<<1; // 1 Bit nach links
}
SDA=0;
pulse_SCL();
}


void I2c_read()
{
dat=0;
_pbc2=1; //_pa4 ist hier Eingang
mydelay(1);
for(j=0;j<8;j++)
{
dat=dat<<1; // 1 Bit nach links
mydelay(1);
SCL=1;
mydelay(1);
if(SDA)
{
//A_Reg=1;
//WrCOM();	
dat=dat+1;
}

mydelay(1);
SCL=0;
mydelay(1);
}
_pbc2=0; //_pa4 ist wieder Ausgang
	
}

void Adr1_write()
{
dat=0;
dat=E_Reg;  
mydelay(1);	
I2c_start();
mydelay(1);
I2c_write();
}	

void Reg_write()
{
dat=E_Reg;
I2c_write();
mydelay(1);
I2c_init(); //neu
mydelay(1);
I2c_start();
}	

void Adr2_write()
{
dat=E_Reg;
I2c_write(); 
mydelay(1);
}	

void Frq_lesen()
{
E_Reg=0x6E;	
Adr1_write();

E_Reg=0x13;
Reg_write();

E_Reg=0x6F;
Adr2_write();

I2c_read();  
mydelay(1);
dat_hi=dat;
I2c_ack();  
mydelay(1);
I2c_read(); 
mydelay(1);
dat_low=dat;
mydelay(1);
I2c_noack();
mydelay(1);
I2c_stop();
mydelay(1);
}	

void Lautst_lesen()
{

E_Reg=0x6E;	
Adr1_write();

E_Reg=0x04;
Reg_write();

E_Reg=0x6F;
Adr2_write();

I2c_read(); // 1. Wert
mydelay(1); 
I2c_ack();  
mydelay(1);
I2c_read(); // 2. Wert
mydelay(1);
mydelay(1);
I2c_noack();
mydelay(1);
I2c_stop();
mydelay(1);
}    	


void LCD_cmd()
{
//RW=0, da an GND
RS_LCD=0; 
_pa=E_Reg;
E_LCD=1;
mydelay(1);
E_LCD=0;
}

void LCD_char()
{
//RW=0, da an GND	
RS_LCD=1;
_pa=E_Reg;
E_LCD=1;
mydelay(1);
E_LCD=0;
}

void LCD_blk()
{
E_Reg=0x02;  //loeschen
LCD_cmd();
}

LCD_init()
{
E_LCD=0;
E_Reg=0x38;
LCD_cmd();
E_Reg=0x0E;
LCD_cmd();
E_Reg=0x01;
LCD_cmd();
}

void Null_ausbl()
{
if(E_Reg==0)
{
E_Reg=32;        //Blank, Null ausblenden
A_Reg=E_Reg;
WrCOM();
LCD_char();	
}

else             // bei Fequenzen ueber 99.9 MHz 
{
E_Reg=E_Reg+48;  //1. Ziffer
A_Reg=E_Reg;
WrCOM();
LCD_char();	
}
}



void main(){
	
	safeguard_init();
	_pac=0;// Port a Ausgang
	_pbc0=0;  // hier Ausgang
    _pdc0=0;  // Ausgang TXD
    _pbc3=0;  // Ausgang SCL
    _pbc2=0;  // Ausgang/Eingang SDA
    _pbc1=0;  // Ausgang E am LCD-Modul 
     _pd0=1;  // TXD = 1
     _eadi=0; //Kein Interupt
     i=0;
    _pbc2=0; // pb2 SDA ist zuerst Ausgang
    _pb3=0;  // pb3 SCL ist stets Ausgang
        

 
//A_Reg=85; //  Test    
//WrCOM(); //
//A_Reg=170; // Test 
//WrCOM(); //

I2c_init();

_pa=0;
mydelay(4);   // ca. 15ms  warten
LCD_init();
mydelay(55);  // ca. 200ms warten


I2c_start();  // Zuerst Lautstaerkewert  
E_Reg=0x6E;   // verringern auf 8
I2c_write();
mydelay(1);
E_Reg=0x04;
I2c_write();
mydelay(1);
E_Reg=0x40;
I2c_write();
mydelay(1);
E_Reg=0x08;
I2c_write();
mydelay(1);
I2c_stop();


    
while(1) 
{ 
	 
Frq_lesen();
//Umrechnung in 'brauchbare' Werte
F=dat_hi*256;
F=F+dat_low;
mydelay(50);
F=F*5;
F=F+6400;
F_high=F /256;
F_hi=F_high & 255;
//A_Reg=F_high; // Test
//WrCOM();
mydelay(1);
F_low= F % 256;
//A_Reg=F_low;  // Test
//WrCOM();
mydelay(100);
//Lautstaerkewerte
Lautst_lesen();
//A_Reg=dat;    // Test
//WrCOM();

mydelay(1);
E_Reg=1;
LCD_cmd();
E_Reg=2;
LCD_cmd();
E_Reg=128;
LCD_cmd();

E_Reg=70;    // F
LCD_char();
mydelay(1);
E_Reg=114;   // r
LCD_char();
mydelay(1);
E_Reg=101;   // e
LCD_char();	
E_Reg=113;   // q
LCD_char();	
E_Reg=46;    // .
LCD_char();	
E_Reg=58;    // :
LCD_char();	

E_Reg=F /10000;

Null_ausbl();

F=F%10000;
E_Reg=F/1000;
E_Reg=E_Reg+48;  //2. Ziffer
A_Reg=E_Reg;
WrCOM();
LCD_char();	

F=F%1000;        //3. Ziffer
E_Reg=F/100;
E_Reg=E_Reg+48;
A_Reg=E_Reg;
WrCOM();
LCD_char();

E_Reg=46;       // Dezimalpunkt
A_Reg=E_Reg;
WrCOM();
LCD_char();

F=F%100;
E_Reg=F/10;
E_Reg=E_Reg+48;
A_Reg=E_Reg;
WrCOM();
LCD_char();

E_Reg=32;       // Blank
A_Reg=E_Reg;
WrCOM();
LCD_char();

E_Reg=77;       // M
A_Reg=E_Reg;
WrCOM();
LCD_char();

E_Reg=72;       // H
A_Reg=E_Reg;
WrCOM();
LCD_char();

E_Reg=122;      // z
A_Reg=E_Reg;
WrCOM();
LCD_char();

E_Reg=192;      // in 2. Zeile
LCD_cmd();

A_Reg=32; // Blank
WrCOM();

A_Reg=32; // Blank
WrCOM();

E_Reg=76;      // L
A_Reg=E_Reg;
WrCOM();
LCD_char();

E_Reg=97;      // a
LCD_char();

E_Reg=117;     // u
LCD_char();

E_Reg=116;     // t
LCD_char();

E_Reg=115;     // s
LCD_char();

E_Reg=116;     // t
LCD_char();

E_Reg=46;      // .
LCD_char();

E_Reg=58;      // :
A_Reg=E_Reg;
WrCOM();
LCD_char();

E_Reg=32;      // Blank
A_Reg=E_Reg;
WrCOM();
LCD_char();

E_Reg=dat/10;  // 1. Ziffer
Null_ausbl();

E_Reg=dat%10;  // 2. Ziffer
E_Reg=E_Reg+48;
A_Reg=E_Reg;
WrCOM();
LCD_char();

A_Reg=13;      // CR
WrCOM();

A_Reg=10;      // LF
WrCOM();

mydelay(200);
mydelay(200);
}
}